list(APPEND CMAKE_MESSAGE_CONTEXT FindNetCDF_Fortran)

if(NOT TARGET NetCDF_Fortran::netcdff)
  find_package(PkgConfig REQUIRED)
  set(prev_env "$ENV{PKG_CONFIG_ALLOW_SYSTEM_CFLAGS}")
  set(ENV{PKG_CONFIG_ALLOW_SYSTEM_CFLAGS} 1)
  pkg_check_modules(netcdff REQUIRED IMPORTED_TARGET GLOBAL
    netcdf-fortran)
  set(ENV{PKG_CONFIG_ALLOW_SYSTEM_CFLAGS} "$prev_env")
  pkg_get_variable(nf_pcfiledir netcdf-fortran pcfiledir)
  message(DEBUG "Location of .pc file: ${nf_pcfiledir}")
  message(DEBUG "PKG_CONFIG_EXECUTABLE: ${PKG_CONFIG_EXECUTABLE}")
  message(VERBOSE "netcdff_INCLUDE_DIRS: ${netcdff_INCLUDE_DIRS}")
  message(DEBUG "netcdff_INCLUDEDIR: ${netcdff_INCLUDEDIR}")
  message(VERBOSE "NetCDF-Fortran libraries: ${netcdff_LINK_LIBRARIES}")
  add_library(NetCDF_Fortran::netcdff ALIAS PkgConfig::netcdff)
endif()

set(NetCDF_Fortran_FOUND True)
list(POP_BACK CMAKE_MESSAGE_CONTEXT)
